/*
**	Structure DLL Header
**		version 1.10.2
*/
/*
Copyright(c)2023 ЃgXgE\tgEFAEVXe, All Rights Reserved.
*/

#ifndef	STRUCTURE_H
#define	STRUCTURE_H

#include <Windows.h>

#ifdef DLL_EXPORTS
#ifndef MLPAPI
#define MLPAPI __declspec(dllexport)
#endif
#else
#ifdef MLPAPI
#undef MLPAPI
#endif
#define MLPAPI __declspec(dllimport)
#endif

#ifdef	WINAPI
#undef	WINAPI
#endif
#define	WINAPI	__stdcall

#include "MlpDeclaration.h"

#ifdef	_UNICODE
#ifndef IMAGER_LP_H
#define	MlpInitialize			MlpInitializeW
#define	MlpAddLicense			MlpAddLicenseW
#define	MlpGetLicenseInfo		MlpGetLicenseInfoW
#define	MlpLoadInitFile			MlpLoadInitFileW
#define	MlpLoadInitData			MlpLoadInitDataW
#define	MlpOpenDoc0				MlpOpenDoc0W
#define	MlpOpenDoc				MlpOpenDocW
#define	MlpOpenDocLegacy		MlpOpenDocLegacyW
#define	MlpOpenDocUsage			MlpOpenDocUsageW
#define	MlpOpenMemDoc			MlpOpenMemDocW
#define	MlpOpenMemDocUsage		MlpOpenMemDocUsageW
#define	MlpSetImageWatermark	MlpSetImageWatermarkW
#define	MlpSetFillTextWatermark	MlpSetFillTextWatermarkW
#define	MlpSetStrokeTextWatermark	MlpSetStrokeTextWatermarkW
#define	MlpCreatePict			MlpCreatePictW
#define	MlpCreatePictData		MlpCreatePictDataW
#define	MlpPageToPict			MlpPageToPictW
#define	MlpPageToPictData		MlpPageToPictDataW
#define	MlpConvertToTiff		MlpConvertToTiffW
#define	MlpCreateTiffRange		MlpCreateTiffRangeW
#define	MlpCreateTiffMulti		MlpCreateTiffMultiW
#define	MlpPageRangeToTiff		MlpPageRangeToTiffW
#define	MlpMultiPageToTiff		MlpMultiPageToTiffW
#define	MlpCreateAllToTiff		MlpCreateAllToTiffW
#define	MlpCreateAllToPict		MlpCreateAllToPictW
#define	MlpPanelToFile			MlpPanelToFileW
#define	MlpPaintRectToPanel_2	MlpPaintRectToPanel_2W
#define MlpCreatePDF			MlpCreatePDFW
#define MlpCreatePDFFile		MlpCreatePDFFileW
#define MlpCreatePDFArray		MlpCreatePDFArrayW
#define MlpAppendToPDF			MlpAppendToPDFW

#define	MlpSetColorProfile		MlpSetColorProfileW
#define	MlpSetRGBProfile		MlpSetRGBProfileW
#define	MlpSetCMYKProfile		MlpSetCMYKProfileW
#define	MlpSetGrayProfile		MlpSetGrayProfileW
#define	MlpGetRGBProfileName	MlpGetRGBProfileNameW
#define	MlpGetCMYKProfileName	MlpGetCMYKProfileNameW
#define	MlpGetGrayProfileName	MlpGetGrayProfileNameW
#define MlpSetDefaultFont		MlpSetDefaultFontW
#define MlpSetAlternateFont		MlpSetAlternateFontW
#define MlpSetAlternateFont2	MlpSetAlternateFont2W
#define MlpSavePDF				MlpSavePDFW
#define MlpSaveLastPDF			MlpSaveLastPDFW
#define MlpConvertToLastVersion	MlpConvertToLastVersionW
#define MlpCountDocumentVersion	MlpCountDocumentVersionW

#if 1	/*Original*/
#define MlpSimpleFontListGetName MlpSimpleFontListGetNameW
#else	/*2022.11.15*/
#define MlpSimpleFontListGetName MlpGetFontListSimpleNameW
#define MlpGetFontListSimpleName MlpGetFontListSimpleNameW
#endif

#endif
#else
#ifndef IMAGER_LP_H
#define	MlpInitialize			MlpInitializeA
#define	MlpAddLicense			MlpAddLicenseA
#define	MlpGetLicenseInfo		MlpGetLicenseInfoA
#define	MlpLoadInitFile			MlpLoadInitFileA
#define	MlpLoadInitData			MlpLoadInitDataA
#define	MlpOpenDoc0				MlpOpenDoc0A
#define	MlpOpenDoc				MlpOpenDocA
#define	MlpOpenDocLegacy		MlpOpenDocLegacyA
#define	MlpOpenDocUsage			MlpOpenDocUsageA
#define	MlpOpenMemDoc			MlpOpenMemDocA
#define	MlpOpenMemDocUsage		MlpOpenMemDocUsageA
#define	MlpSetImageWatermark	MlpSetImageWatermarkA
#define	MlpSetFillTextWatermark	MlpSetFillTextWatermarkA
#define	MlpSetStrokeTextWatermark	MlpSetStrokeTextWatermarkA
#define	MlpCreatePict			MlpCreatePictA
#define	MlpCreatePictData		MlpCreatePictDataA
#define	MlpPageToPict			MlpPageToPictA
#define	MlpPageToPictData		MlpPageToPictDataA
#define	MlpConvertToTiff		MlpConvertToTiffA
#define	MlpCreateTiffRange		MlpCreateTiffRangeA
#define	MlpCreateTiffMulti		MlpCreateTiffMultiA
#define	MlpRangeToTiff			MlpRangeToTiffA
#define	MlpMultiPageToTiff		MlpMultiPageToTiffA
#define	MlpCreateAllToTiff		MlpCreateAllToTiffA
#define	MlpCreateAllToPict		MlpCreateAllToPictA
#define	MlpPanelToFile			MlpPanelToFileA
#define	MlpPaintRectToPanel_2	MlpPaintRectToPanel_2A
#define MlpCreatePDF			MlpCreatePDFA
#define MlpCreatePDFFile		MlpCreatePDFFileA
#define MlpCreatePDFArray		MlpCreatePDFArrayA
#define MlpAppendToPDF			MlpAppendToPDFA

#define	MlpSetColorProfile		MlpSetColorProfileA
#define	MlpSetRGBProfile		MlpSetRGBProfileA
#define	MlpSetCMYKProfile		MlpSetCMYKProfileA
#define	MlpSetGrayProfile		MlpSetGrayProfileA
#define	MlpGetRGBProfileName	MlpGetRGBProfileNameA
#define	MlpGetCMYKProfileName	MlpGetCMYKProfileNameA
#define	MlpGetGrayProfileName	MlpGetGrayProfileNameA
#define MlpSetDefaultFont		MlpSetDefaultFontA
#define MlpSetAlternateFont		MlpSetAlternateFontA
#define MlpSetAlternateFont2	MlpSetAlternateFont2A
#define MlpSavePDF				MlpSavePDFA
#define MlpSaveLastPDF			MlpSaveLastPDFA
#define MlpConvertToLastVersion	MlpConvertToLastVersionA
#define MlpCountDocumentVersion	MlpCountDocumentVersionA

#define MlpSimpleFontListGetName MlpSimpleFontListGetNameA

#endif
#endif

#ifdef _UNICODE
#define	ModRegisterFont		ModRegisterFontW
#define	ModSetFontName		ModSetFontNameW
#define	ModGetFontName		ModGetFontNameW
#define	ModRegisterImage	ModRegisterImageW
#define	ModSetImageName		ModSetImageNameW
#define	ModGetImageName		ModGetImageNameW
#define	ModPaintText		ModPaintTextW
#define	ModPaintTextArg		ModPaintTextArgW
#else
#define	ModRegisterFont		ModRegisterFontA
#define	ModSetFontName		ModSetFontNameA
#define	ModGetFontName		ModGetFontNameA
#define	ModRegisterImage	ModRegisterImageA
#define	ModSetImageName		ModSetImageNameA
#define	ModGetImageName		ModGetImageNameA
#define	ModPaintText		ModPaintTextA
#define	ModPaintTextArg		ModPaintTextArgA
#endif // _UNICODE

#ifdef _UNICODE
#define	MlpSetStampFile			MlpSetStampFileW
#define	MlpSetStampData			MlpSetStampDataW
#define	MlpPaintStampFile		MlpPaintStampFileW
#define	MlpPaintStampFile		MlpPaintStampFileW
#define	MlpPaintStampData		MlpPaintStampDataW
#define	MlpSetStampSingleFile	MlpSetStampSingleFileW
#define	MlpSetStampSingleData	MlpSetStampSingleDataW
#define	MlpPaintStampSinglFile	MlpPaintStampSinglFileW
#define	MlpPaintStampSinglData	MlpPaintStampSinglDataW
#define	MlpPaintStampName		MlpPaintStampNameW
#define	MlpPaintStampNamePos	MlpPaintStampNamePosW

#define	PrmDocumentToFile		PrmDocumentToFileW

#define	StmPaintStampName		StmPaintStampNameW
#define	StmSetStampData			StmSetStampDataW
#define	StmPaintStampFile		StmPaintStampFileW
#define	StmPaintStampData		StmPaintStampDataW
#define	StmPaintStampName		StmPaintStampNameW
#define	StmPaintStampNamePos	StmPaintStampNamePosW
#else
#define	MlpSetStampFile			MlpSetStampFileA
#define	MlpSetStampData			MlpSetStampDataA
#define	MlpPaintStampFile		MlpPaintStampFileA
#define	MlpPaintStampFile		MlpPaintStampFileA
#define	MlpPaintStampData		MlpPaintStampDataA
#define	MlpSetStampSingleFile	MlpSetStampSingleFileA
#define	MlpSetStampSingleData	MlpSetStampSingleDataA
#define	MlpPaintStampSinglFile	MlpPaintStampSinglFileA
#define	MlpPaintStampSinglData	MlpPaintStampSinglDataA
#define	MlpPaintStampName		MlpPaintStampNameA
#define	MlpPaintStampNamePos	MlpPaintStampNamePosA

#define	PrmDocumentToFile		PrmDocumentToFileA

#define	StmPaintStampName		StmPaintStampNameA
#define	StmSetStampData			StmSetStampDataA
#define	StmPaintStampFile		StmPaintStampFileA
#define	StmPaintStampData		StmPaintStampDataA
#define	StmPaintStampName		StmPaintStampNameA
#define	StmPaintStampNamePos	StmPaintStampNamePosA
#endif // _UNICODEMlpPaintStampNameW

/* XMP */
#ifdef _UNICODE
#define	XmpDoesPropertyExist		XmpDoesPropertyExistW
#define	XmpDoesSimplePropertyExist	XmpDoesSimplePropertyExistW
#define	XmpDoesArrayPropertyExist	XmpDoesArrayPropertyExistW
#define	XmpDoesArrayItemExist		XmpDoesArrayItemExistW
#define	XmpDoesStructPropertyExist	XmpDoesStructPropertyExistW
#define	XmpDoesStructFieldExist		XmpDoesStructFieldExistW
#define	XmpGetSimpleProperty		XmpGetSimplePropertyW
#define	XmpGetArrayItem				XmpGetArrayItemW
#define	XmpCountArrayItems			XmpCountArrayItemsW
#define	XmpGetStructField			XmpGetStructFieldW
#define	XmpSetSimpleProperty		XmpSetSimplePropertyW
#define	XmpSetArrayItem				XmpSetArrayItemW
#define	XmpAppendArrayItem			XmpAppendArrayItemW
#define	XmpSetStructField			XmpSetStructFieldW
#define	XmpDeleteProperty			XmpDeletePropertyW
#define	XmpDeleteSimpleProperty		XmpDeleteSimplePropertyW
#define	XmpDeleteArrayItem			XmpDeleteArrayItemW
#define	XmpDeleteStructField		XmpDeleteStructFieldW
#define	XmpCreateArrayProperty		XmpCreateArrayPropertyW
#define	XmpCreateOrderedArrayProperty XmpCreateOrderedArrayPropertyW
#define	XmpCreateAlternateArrayProperty XmpCreateAlternateArrayPropertyW
#define	XmpCreateStructProperty		XmpCreateStructPropertyW
#define	XmpSetSimplePropertyCurrentDate	XmpSetSimplePropertyCurrentDateW
#define	XmpSetSimplePropertyDate	XmpSetSimplePropertyDateW
#define	XmpGetPropertyDate			XmpGetPropertyDateW
#define	XmpDumpObjectToFile			XmpDumpObjectToFileW
#define	XmpDumpObjectToChar			XmpDumpObjectToCharW
#define	XmpRegisterNamespace		XmpRegisterNamespaceW
#define	XmpGetLastError				XmpGetLastErrorW
#else
#define	XmpDoesPropertyExist		XmpDoesPropertyExistA
#define	XmpDoesSimplePropertyExist	XmpDoesSimplePropertyExistA
#define	XmpDoesArrayPropertyExist	XmpDoesArrayPropertyExistA
#define	XmpDoesArrayItemExist		XmpDoesArrayItemExistA
#define	XmpDoesStructPropertyExist	XmpDoesStructPropertyExistA
#define	XmpDoesStructFieldExist		XmpDoesStructFieldExistA
#define	XmpGetSimpleProperty		XmpGetSimplePropertyA
#define	XmpGetArrayItem				XmpGetArrayItemA
#define	XmpCountArrayItems			XmpCountArrayItemsA
#define	XmpGetStructField			XmpGetStructFieldA
#define	XmpSetSimpleProperty		XmpSetSimplePropertyA
#define	XmpSetArrayItem				XmpSetArrayItemA
#define	XmpAppendArrayItem			XmpAppendArrayItemA
#define	XmpSetStructField			XmpSetStructFieldA
#define	XmpDeleteProperty			XmpDeletePropertyA
#define	XmpDeleteSimpleProperty		XmpDeleteSimplePropertyA
#define	XmpDeleteArrayItem			XmpDeleteArrayItemA
#define	XmpDeleteStructField		XmpDeleteStructFieldA
#define	XmpCreateArrayProperty		XmpCreateArrayPropertyA
#define	XmpCreateOrderedArrayProperty XmpCreateOrderedArrayPropertyA
#define	XmpCreateAlternateArrayProperty XmpCreateAlternateArrayPropertyA
#define	XmpCreateStructProperty		XmpCreateStructPropertyA
#define	XmpSetSimplePropertyCurrentDate	XmpSetSimplePropertyCurrentDateA
#define	XmpSetSimplePropertyDate	XmpSetSimplePropertyDateA
#define	XmpGetPropertyDate			XmpGetPropertyDateA
#define	XmpDumpObjectToFile			XmpDumpObjectToFileA
#define	XmpDumpObjectToChar			XmpDumpObjectToCharA
#define	XmpRegisterNamespace		XmpRegisterNamespaceA
#define	XmpGetLastError				XmpGetLastErrorA
#endif // _UNICODE

#ifdef	__cplusplus
extern "C" {
#endif

#ifndef IMAGER_LP_H

	/**/
	MLPAPI int WINAPI MlpInitializeA(const char* license);
	MLPAPI int WINAPI MlpInitializeW(const wchar_t* license);
	MLPAPI int WINAPI MlpUninitialize();
	MLPAPI int WINAPI MlpAddLicenseA(const char* license);
	MLPAPI void WINAPI MlpSetErrorStyle(int style);

	/*f[^*/
	MLPAPI int WINAPI MlpLoadInitFileW(const wchar_t* fileName);
	MLPAPI int WINAPI MlpLoadInitFileA(const char* fileName);
	MLPAPI int WINAPI MlpLoadInitDataW(const wchar_t* data, int len);
	MLPAPI int WINAPI MlpLoadInitDataA(const char* data, int len);

	/*CZX*/
	MLPAPI void WINAPI MlpShowLicenseInfo();
	MLPAPI char* WINAPI MlpGetLicenseInfoA();
	MLPAPI wchar_t* WINAPI MlpGetLicenseInfoW();

	/*I[v*/
	MLPAPI int WINAPI MlpOpenDoc0W(const wchar_t* fileName, const wchar_t* ownerPassword, const wchar_t* userPassword);
	MLPAPI int WINAPI MlpOpenDoc0A(const char* fileName, const char* ownerPassword, const char* userPassword);
	MLPAPI int WINAPI MlpOpenDocW(const wchar_t* fileName, const wchar_t* password);
	MLPAPI int WINAPI MlpOpenDocA(const char* fileName, const char* password);
	MLPAPI int WINAPI MlpOpenDocLegacyW(const wchar_t* fileName, const wchar_t* ownerPassword, const wchar_t* userPassword);
	MLPAPI int WINAPI MlpOpenDocLegacyA(const char* fileName, const char* ownerPassword, const char* userPassword);
	MLPAPI int WINAPI MlpOpenNewDoc(float width, float height, int rotate, void*);
	MLPAPI int WINAPI MlpOpenDocUsageW(const wchar_t* fileName, const wchar_t* password, int usage);
	MLPAPI int WINAPI MlpOpenDocUsageA(const char* fileName, const char* password, int usage);
	MLPAPI int WINAPI MlpOpenMemDocA(unsigned char* data, size_t length, const char* password);
	MLPAPI int WINAPI MlpOpenMemDocUsageA(unsigned char* data, size_t len, const char* password, int usage);
	MLPAPI int WINAPI MlpCloseDoc();

	/*Cu*/
	MLPAPI int WINAPI MlpGetLibraryInfo(int cmd, ...);
	MLPAPI int WINAPI MlpGetMinimumLineWidth(float*);
	MLPAPI int WINAPI MlpGetPictureXResolution();
	MLPAPI int WINAPI MlpGetPictureYResolution();
	MLPAPI int WINAPI MlpGetPictureQuality();
	MLPAPI int WINAPI MlpGetFillPathAALevel();

	/**/
	MLPAPI int WINAPI MlpGetDocumentInfo(int cmd, ...);
	MLPAPI int WINAPI MlpPageCount();
	MLPAPI int WINAPI MlpGetPageCount();
	MLPAPI int WINAPI MlpGetMetadata(unsigned char** metadata);
	MLPAPI int WINAPI MlpPrintRestriction();
	MLPAPI int WINAPI MlpCountDocumentUpdates();
	MLPAPI int WINAPI MlpSaveLastPDFA(const char* fileName);
	MLPAPI int WINAPI MlpSaveLastPDFW(const wchar_t* fileName);
	MLPAPI int WINAPI MlpSimpleFontListGetNameA(int number, char** fontName, int* embeddedFlag, int* fontType);
	MLPAPI int WINAPI MlpSimpleFontListGetNameW(int number, wchar_t** fontName, int* embeddedFlag, int* fontType);
	MLPAPI int WINAPI MlpGetFontListA(MlpFontList**);
	MLPAPI int WINAPI MlpGetFontListW(MlpFontList**);
	MLPAPI int WINAPI MlpGetFontListU8(MlpFontList**);
	MLPAPI MlpFormData WINAPI MlpInteractiveFormFirstData();
	MLPAPI MlpFormData WINAPI MlpInteractiveFormNextData();

	/*PrimitiveC^[tF[X*/
	MLPAPI PRIMITIVE_HANDLE WINAPI MlpGetPrimitiveInterface();
	MLPAPI void WINAPI MlpFinishPrimitiveInterface();
	MLPAPI void WINAPI PrmCloseInterface(PRIMITIVE_HANDLE);
	MLPAPI int WINAPI PrmDocumentToFileA(PRIMITIVE_HANDLE, char* outputFilePath);
	MLPAPI int WINAPI PrmDocumentToFileW(PRIMITIVE_HANDLE, wchar_t* outputFilePath);

	MLPAPI int WINAPI PrmShowXref(PRIMITIVE_HANDLE);
	MLPAPI int WINAPI PrmShowTrailer(PRIMITIVE_HANDLE, int pretty);
	MLPAPI int WINAPI PrmShowCatalog(PRIMITIVE_HANDLE, int pretty);
	MLPAPI int WINAPI PrmShowDocumentInformation(PRIMITIVE_HANDLE, int pretty);
	MLPAPI int WINAPI PrmShowPageTree(PRIMITIVE_HANDLE, int pretty);
	MLPAPI int WINAPI PrmShowIndirectObject(PRIMITIVE_HANDLE, unsigned int objectNumber, int pretty);
	MLPAPI int WINAPI PrmShowIndirectObjectWithStream(PRIMITIVE_HANDLE, unsigned int objectNumber, int pretty, int ascii);
	MLPAPI int WINAPI PrmShowStream(PRIMITIVE_HANDLE, unsigned int objectNumber);

	MLPAPI int WINAPI PrmStringXref(PRIMITIVE_HANDLE, char **data);
	MLPAPI int WINAPI PrmStringTrailer(PRIMITIVE_HANDLE, int pretty, char **data);
	MLPAPI int WINAPI PrmStringCatalog(PRIMITIVE_HANDLE, int pretty, char **data);
	MLPAPI int WINAPI PrmStringDocumentInformation(PRIMITIVE_HANDLE, int pretty, char **data);
	MLPAPI int WINAPI PrmStringPageTree(PRIMITIVE_HANDLE, int pretty, char **data);
	MLPAPI int WINAPI PrmStringIndirectObject(PRIMITIVE_HANDLE, unsigned int objectNumber, int pretty, char **data);
	MLPAPI int WINAPI PrmStringStream(PRIMITIVE_HANDLE, unsigned int objectNumber, char **data);

	MLPAPI int WINAPI PrmIndirectObjectHasStream(PRIMITIVE_HANDLE, unsigned int objectNumber);
	MLPAPI int WINAPI PrmGetXrefOffset(PRIMITIVE_HANDLE);
	MLPAPI int WINAPI PrmIsXrefTable(PRIMITIVE_HANDLE);
	MLPAPI int WINAPI PrmIsXrefStream(PRIMITIVE_HANDLE, int* num, int* gen);
	MLPAPI int WINAPI PrmXrefTable(PRIMITIVE_HANDLE, PrmDocumentXref** data);
	MLPAPI int WINAPI PrmXrefStream(PRIMITIVE_HANDLE, PrmDocumentXref** data);

	MLPAPI PrmObjectHandle WINAPI PrmObjectHandleTrailer(PRIMITIVE_HANDLE);
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandleCatalog(PRIMITIVE_HANDLE);
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandleDocumentInformation(PRIMITIVE_HANDLE);
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandlePageTree(PRIMITIVE_HANDLE);
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandlePage(PRIMITIVE_HANDLE, int pageNumber);	/*2022.7.19*/
	MLPAPI int WINAPI PrmObjectHandleGetStream(PRIMITIVE_HANDLE, PrmObjectHandle referenceObject, unsigned char** data);	/*2022.7.19*/
	MLPAPI int WINAPI PrmObjectHandleSetStream(PRIMITIVE_HANDLE, PrmObjectHandle referenceObject, unsigned char* data, unsigned int length);	/*2022.7.19*/
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandleIndirect(PRIMITIVE_HANDLE, unsigned int objectNumber);
	MLPAPI int WINAPI PrmObjectHandleLength(PRIMITIVE_HANDLE, PrmObjectHandle);
	MLPAPI int WINAPI PrmObjectHandleHasStream(PRIMITIVE_HANDLE, PrmObjectHandle);

	MLPAPI int WINAPI PrmObjectHandleDictionaryLength(PRIMITIVE_HANDLE, PrmObjectHandle dictionaryObject);
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandleDictionaryKey(PRIMITIVE_HANDLE, PrmObjectHandle dictionaryObject, unsigned int index);
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandleDictionaryValue(PRIMITIVE_HANDLE, PrmObjectHandle dictionaryObject, unsigned int index);
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandleDictionaryByString(PRIMITIVE_HANDLE, PrmObjectHandle dictionaryObject, const char *key);
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandleDictionaryByObject(PRIMITIVE_HANDLE, PrmObjectHandle dictionaryObject, PrmObjectHandle key);
	MLPAPI int WINAPI PrmObjectHandleArrayLength(PRIMITIVE_HANDLE, PrmObjectHandle arryObject);
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandleArrayValue(PRIMITIVE_HANDLE, PrmObjectHandle arryObject, unsigned int index);
	MLPAPI int WINAPI PrmObjectHandleReferenceToNumber(PRIMITIVE_HANDLE, PrmObjectHandle);
	MLPAPI int WINAPI PrmObjectHandleReferenceToGeneration(PRIMITIVE_HANDLE, PrmObjectHandle);
	MLPAPI PrmObjectHandle WINAPI PrmObjectHandleReferenceToObject(PRIMITIVE_HANDLE, PrmObjectHandle);

	MLPAPI int WINAPI PrmObjectHandleToBool(PRIMITIVE_HANDLE, PrmObjectHandle);
	MLPAPI int WINAPI PrmObjectHandleToInt(PRIMITIVE_HANDLE, PrmObjectHandle);
	MLPAPI float WINAPI PrmObjectHandleToReal(PRIMITIVE_HANDLE, PrmObjectHandle);
	MLPAPI char* WINAPI PrmObjectHandleToStr(PRIMITIVE_HANDLE, PrmObjectHandle);
	MLPAPI char* WINAPI PrmObjectHandleToName(PRIMITIVE_HANDLE, PrmObjectHandle);
	MLPAPI int WINAPI PrmShowObjectHandle(PRIMITIVE_HANDLE, PrmObjectHandle, int resolve, int stream, int pretty);
	MLPAPI int WINAPI PrmStringObjectHandle(PRIMITIVE_HANDLE, PrmObjectHandle, int resolve, int stream, int pretty, char **data);

	/*XMPC^[tF[X*/
	MLPAPI XMP_HANDLE WINAPI MlpGetXmpInterface();
	MLPAPI int WINAPI XmpDocumentToFile(XMP_HANDLE, const char *fileName);
	MLPAPI void WINAPI XmpCloseInterface(XMP_HANDLE);
	MLPAPI int WINAPI XmpDoesPropertyExistA(XMP_HANDLE, const char *namespaceURI, const char *propertyName);
	MLPAPI int WINAPI XmpDoesPropertyExistW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop);
	MLPAPI int WINAPI XmpDoesSimplePropertyExistA(XMP_HANDLE, const char *namespaceURI, const char *propertyName);
	MLPAPI int WINAPI XmpDoesSimplePropertyExistW(XMP_HANDLE, const wchar_t *namespaceURI, const wchar_t *propertyName);
	MLPAPI int WINAPI XmpDoesArrayPropertyExistA(XMP_HANDLE, const char *namespaceURI, const char *propertyName);
	MLPAPI int WINAPI XmpDoesArrayPropertyExistW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop);
	MLPAPI int WINAPI XmpDoesArrayItemExistA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, int itemIndex);
	MLPAPI int WINAPI XmpDoesArrayItemExistW(XMP_HANDLE, const wchar_t*namespaceURI, const wchar_t*propertyName, int itemIndex);
	MLPAPI int WINAPI XmpDoesStructPropertyExistA(XMP_HANDLE, const char *namespaceURI, const char *propertyName);
	MLPAPI int WINAPI XmpDoesStructPropertyExistW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop);
	MLPAPI int WINAPI XmpDoesStructFieldExistA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, const char *fieldUri, const char *fieldName);
	MLPAPI int WINAPI XmpDoesStructFieldExistW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop, const wchar_t* fieldUri, const wchar_t* fieldName);
	MLPAPI int WINAPI XmpGetSimplePropertyA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, char **simpleValue);
	MLPAPI int WINAPI XmpGetSimplePropertyW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop, wchar_t** value);
	MLPAPI int WINAPI XmpGetArrayItemA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, int itemIndex, char **arrayValue);
	MLPAPI int WINAPI XmpGetArrayItemW(XMP_HANDLE, const wchar_t* namespaceURI, const wchar_t* propertyName, int itemIndex, wchar_t** arrayValue);
	MLPAPI int WINAPI XmpCountArrayItemsA(XMP_HANDLE, const char *namespaceURI, const char *propertyName);
	MLPAPI int WINAPI XmpCountArrayItemsW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop);
	MLPAPI int WINAPI XmpGetStructFieldA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, const char *fieldUri, const char *fieldName, char **fieldValue);
	MLPAPI int WINAPI XmpGetStructFieldW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop, const wchar_t* fieldUri, const wchar_t* fieldName, wchar_t** fieldValue);
	MLPAPI int WINAPI XmpSetSimplePropertyA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, const char *simpleValue);
	MLPAPI int WINAPI XmpSetSimplePropertyW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop, const wchar_t* simpleValue);
	MLPAPI int WINAPI XmpSetArrayItemA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, int itemIndex, const char *arrayItemValue);
	MLPAPI int WINAPI XmpSetArrayItemW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop, int itemIndex, const wchar_t* arrayItemValue);
	MLPAPI int WINAPI XmpAppendArrayItemA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, unsigned long arrayOptions, const char *arrayItemValue);
	MLPAPI int WINAPI XmpAppendArrayItemW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop, unsigned long arrayOptions, const wchar_t* arrayItemValue);
	MLPAPI int WINAPI XmpSetStructFieldA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, const char *fieldUri, const char *fieldName, const char *value);
	MLPAPI int WINAPI XmpSetStructFieldW(XMP_HANDLE h, const wchar_t* uri, const wchar_t* prop, const wchar_t* fieldUri, const wchar_t* fieldName, const wchar_t* value);
	MLPAPI int WINAPI XmpDeletePropertyA(XMP_HANDLE, const char *namespaceURI, const char *propertyName);
	MLPAPI int WINAPI XmpDeletePropertyW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop);
	MLPAPI int WINAPI XmpDeleteSimplePropertyA(XMP_HANDLE, const char *namespaceURI, const char *propertyName);
	MLPAPI int WINAPI XmpDeleteSimplePropertyW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop);
	MLPAPI int WINAPI XmpDeleteArrayItemA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, int itemIndex);
	MLPAPI int WINAPI XmpDeleteArrayItemW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop, int itemIndex);
	MLPAPI int WINAPI XmpDeleteStructFieldA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, const char *fieldUri, const char *fieldName);
	MLPAPI int WINAPI XmpDeleteStructFieldW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop, const wchar_t* fieldUri, const wchar_t* fieldName);
	MLPAPI int WINAPI XmpCreateArrayPropertyA(XMP_HANDLE, const char *namespaceURI, const char *propertyName);
	MLPAPI int WINAPI XmpCreateArrayPropertyW(XMP_HANDLE, const wchar_t* namespaceURI, const wchar_t* propertyName);
	MLPAPI int WINAPI XmpCreateOrderedArrayPropertyA(XMP_HANDLE, const char* namespaceURI, const char* propertyName);
	MLPAPI int WINAPI XmpCreateOrderedArrayPropertyW(XMP_HANDLE , const wchar_t* namespaceURI, const wchar_t* propertyName);
	MLPAPI int WINAPI XmpCreateAlternateArrayPropertyA(XMP_HANDLE, const char* namespaceURI, const char* propertyName);
	MLPAPI int WINAPI XmpCreateAlternateArrayPropertyW(XMP_HANDLE, const wchar_t* namespaceURI, const wchar_t* propertyName);
	MLPAPI int WINAPI XmpCreateStructPropertyA(XMP_HANDLE, const char *namespaceURI, const char *propertyName);
	MLPAPI int WINAPI XmpCreateStructPropertyW(XMP_HANDLE h, const wchar_t* uri, const wchar_t* prop);
	MLPAPI int WINAPI XmpSetSimplePropertyCurrentDateA(XMP_HANDLE, const char *namespaceURI, const char *propertyName);
	MLPAPI int WINAPI XmpSetSimplePropertyCurrentDateW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop);
	MLPAPI int WINAPI XmpSetSimplePropertyDateA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, time_t sourceTime);
	MLPAPI int WINAPI XmpSetSimplePropertyDateW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop, time_t srcTime);
	MLPAPI int WINAPI XmpGetPropertyDateA(XMP_HANDLE, const char *namespaceURI, const char *propertyName, time_t*);
	MLPAPI int WINAPI XmpGetPropertyDateW(XMP_HANDLE, const wchar_t* uri, const wchar_t* prop, time_t* datetime);

	MLPAPI int WINAPI XmpDumpObjectToConsole(XMP_HANDLE);
	MLPAPI int WINAPI XmpDumpObjectToFileA(XMP_HANDLE, const char *outputFileName);
	MLPAPI int WINAPI XmpDumpObjectToFileW(XMP_HANDLE, const wchar_t* fileName);
	MLPAPI int WINAPI XmpDumpObjectToCharA(XMP_HANDLE, char **outData);
	MLPAPI int WINAPI XmpDumpObjectToCharW(XMP_HANDLE, wchar_t** data);
	MLPAPI int WINAPI XmpRegisterNamespaceA(XMP_HANDLE, const char *namespaceURI, const char *suggestedPrefix, char **registeredPrefix);
	MLPAPI int WINAPI XmpRegisterNamespaceW(XMP_HANDLE, const wchar_t *namespaceURI, const wchar_t *suggestedPrefix, wchar_t **registeredPrefix);

	MLPAPI int WINAPI XmpUpdateDocument(XMP_HANDLE);
	MLPAPI long WINAPI XmpGetLastErrorA(XMP_HANDLE, char **message);
	MLPAPI long WINAPI XmpGetLastErrorW(XMP_HANDLE, wchar_t** message);

	/*Modify Interface*/
	MLPAPI MOD_HANDLE WINAPI MlpGetModInterface();
	MLPAPI int WINAPI ModCloseInterface(MOD_HANDLE, int flag);
	MLPAPI int WINAPI ModRegisterFontA(MOD_HANDLE , char* requestFontName, char* fontPath, char** fontName);
	MLPAPI int WINAPI ModRegisterFontW(MOD_HANDLE , wchar_t* requestFontName, wchar_t* fontPath, wchar_t** fontName);
	MLPAPI int WINAPI ModRegisterImageA(MOD_HANDLE , char* imagePath, char** imageName);
	MLPAPI int WINAPI ModRegisterImageW(MOD_HANDLE , wchar_t* imagePath, wchar_t** ImageName);
	MLPAPI int WINAPI ModSetFontNameA(MOD_HANDLE, char* fontName);
	MLPAPI int WINAPI ModSetFontNameW(MOD_HANDLE, wchar_t* fontName);
	MLPAPI const char* WINAPI ModGetFontNameA(MOD_HANDLE);
	MLPAPI const wchar_t* WINAPI ModGetFontNameW(MOD_HANDLE);
	MLPAPI float WINAPI ModGetFontSize(MOD_HANDLE);
	MLPAPI int WINAPI ModSetFontSize(MOD_HANDLE, float size);
	MLPAPI float WINAPI ModGetTextLeading(MOD_HANDLE);
	MLPAPI int WINAPI ModSetTextLeading(MOD_HANDLE, float value);
	MLPAPI float WINAPI ModGetCharSpacing(MOD_HANDLE);
	MLPAPI int WINAPI ModSetCharSpacing(MOD_HANDLE, float value);
	MLPAPI int WINAPI ModSetImageNameA(MOD_HANDLE, char* imageName);
	MLPAPI int WINAPI ModSetImageNameW(MOD_HANDLE, wchar_t* imageName);
	MLPAPI const char* WINAPI ModGetImageNameA(MOD_HANDLE);
	MLPAPI const wchar_t* WINAPI ModGetImageNameW(MOD_HANDLE);
	MLPAPI int WINAPI ModSetFillColorArray(MOD_HANDLE, float* colorArray, unsigned char arrayLength);
	MLPAPI int WINAPI ModSetFillColorGray(MOD_HANDLE, float gray);
	MLPAPI int WINAPI ModSetFillColorRGB(MOD_HANDLE, float red, float green, float blue);
	MLPAPI int WINAPI ModSetFillColorCMYK(MOD_HANDLE, float cyan, float magenta, float yellow, float key);
	MLPAPI int WINAPI ModSetStrokeColorArray(MOD_HANDLE, float* colorArray, unsigned char arrayLength);
	MLPAPI int WINAPI ModSetStrokeColorGray(MOD_HANDLE, float gray);
	MLPAPI int WINAPI ModSetStrokeColorRGB(MOD_HANDLE, float red, float green, float blue);
	MLPAPI int WINAPI ModSetStrokeColorCMYK(MOD_HANDLE, float cyan, float magenta, float yellow, float key);
	MLPAPI int WINAPI ModSetTextRenderingMode(MOD_HANDLE, int renderingMode);
	MLPAPI int WINAPI ModSetPathRenderingMode(MOD_HANDLE, int renderingMode);
	MLPAPI int WINAPI ModGetTextRenderingMode(MOD_HANDLE);
	MLPAPI int WINAPI ModGetPathRenderingMode(MOD_HANDLE);
	MLPAPI int WINAPI ModSetTextLineWidth(MOD_HANDLE, float lineWidth);
	MLPAPI int WINAPI ModSetPathLineWidth(MOD_HANDLE, float lineWidth);
	MLPAPI float WINAPI ModGetTextLineWidth(MOD_HANDLE);
	MLPAPI float WINAPI ModGetPathLineWidth(MOD_HANDLE);
	MLPAPI int WINAPI ModSetPathDash(MOD_HANDLE, float* dashArray, int arrayLength, float dashPhase);
	MLPAPI int WINAPI ModClearPathDash(MOD_HANDLE);
	MLPAPI int WINAPI ModSetImageMatrix(MOD_HANDLE, Matrix);
	MLPAPI int WINAPI ModSetTransparent(MOD_HANDLE, float CA, float ca);
	MLPAPI int WINAPI ModPaintTextA(MOD_HANDLE, int pageNumber, float xpos, float ypos, char* text);
	MLPAPI int WINAPI ModPaintTextCS(MOD_HANDLE h, int pageNumber, float xpos, float ypos, wchar_t* text);	//C#p
	MLPAPI int WINAPI ModEndText(MOD_HANDLE, int pageNumber);
	MLPAPI int WINAPI ModPaintTextW(MOD_HANDLE, int pageNumber, float xpos, float ypos, wchar_t* text);
	MLPAPI int WINAPI ModPaintTextArgA(MOD_HANDLE, ModTextArgA* arg);
	MLPAPI int WINAPI ModPaintTextArgW(MOD_HANDLE, ModTextArgW* arg);
	MLPAPI int WINAPI ModPaintRectangle(MOD_HANDLE, int pageNumber, float xpos, float ypos, float width, float height);
	MLPAPI int WINAPI ModPaintLine(MOD_HANDLE, int pageNumber, float xFrom, float yFrom, float xTo, float yTo);
	MLPAPI int WINAPI ModPaintEllipse(MOD_HANDLE, int pageNumber, float xcenter, float ycenter, float width, float height);
	MLPAPI int WINAPI ModPaintImage(MOD_HANDLE, int pageNumber, float xpos, float ypos);
	MLPAPI int WINAPI ModPaintImageSize(MOD_HANDLE, int pageNumber, float xpos, float ypos, float width, float height);
	MLPAPI int WINAPI ModPaintImageScale(MOD_HANDLE, int pageNumber, float xpos, float ypos, float scale);
	MLPAPI int WINAPI ModPaintMatrixValue(MOD_HANDLE, int pageNumber, float a, float b, float c, float d, float e, float f);
	MLPAPI int WINAPI ModPaintMatrixArray(MOD_HANDLE h, int pageNumber, float m[]);

	/*Secure Interface*/

	/*y[W*/
	MLPAPI int WINAPI MlpGetPageRotation(int pageNumber, int* rotate);
	MLPAPI int WINAPI MlpGetPageBoundary(int pageNumber, int kind, float* userUnit, float* left, float* bottom, float* right, float* top);
	MLPAPI int WINAPI MlpGetPageRawBoundary(int pageNumber, int kind, float* userUnit, float* left, float* bottom, float* right, float* top);
	MLPAPI int WINAPI MlpGetPicturePixel(int pageNumber, int* x, int* y);
	MLPAPI int WINAPI MlpGetPicturePixelX(int pageNumber);
	MLPAPI int WINAPI MlpGetPicturePixelY(int pageNumber);
	MLPAPI int WINAPI MlpGetCid0GlyphMode();

	/*ݒ*/
	MLPAPI int WINAPI MlpSetPicture(int opt, ...);
	MLPAPI int WINAPI MlpSetPictureSize(int x, int y, int unit);
	MLPAPI int WINAPI MlpSetPictureResolution(int dpi);
	MLPAPI int WINAPI MlpSetPictureXResolution(int dpi);
	MLPAPI int WINAPI MlpSetPictureYResolution(int dpi);
	MLPAPI int WINAPI MlpSetPictureQuality(int quality);
	MLPAPI int WINAPI MlpSetPicturePixelX(int x);
	MLPAPI int WINAPI MlpSetPicturePixelY(int y);
	MLPAPI int WINAPI MlpSetCanvasSize(int x, int y);
	MLPAPI int WINAPI MlpSetCanvasOrigin(int org);
	MLPAPI int WINAPI MlpSetTiffCompress(int mode);
	MLPAPI int WINAPI MlpSetFillPathAAEnable();
	MLPAPI int WINAPI MlpSetFillPathAADisable();
	MLPAPI int WINAPI MlpSetCid0GlyphMode(int mode);	/*ToBe Obsoleted*/
	MLPAPI int WINAPI MlpSetMinimumLineWidth(float width);
	MLPAPI int WINAPI MlpSetIncrementalUpdate(int flag);
	MLPAPI int WINAPI MlpAlternateAnnotFreeText(char *fontName, float fontSize, int numOfColors, float* colorValues);	/*2023.8.25*/

	/*F*/
	MLPAPI int WINAPI MlpSetPictureRGB();
	MLPAPI int WINAPI MlpSetPictureCMYK();
	MLPAPI int WINAPI MlpSetPictureGray();
	MLPAPI int WINAPI MlpSetPictureBW();
	MLPAPI int WINAPI MlpSetPictureDither();

	/*J[vt@C*/
	MLPAPI int WINAPI MlpUseCMS();
	MLPAPI int WINAPI MlpUnuseCMS();
	MLPAPI int WINAPI MlpSetColorProfileW(const wchar_t* fileName);
	MLPAPI int WINAPI MlpSetRGBProfileW(const wchar_t* fileName);
	MLPAPI int WINAPI MlpSetCMYKProfileW(const wchar_t* fileName);
	MLPAPI int WINAPI MlpSetGrayProfileW(const wchar_t* fileName);
	MLPAPI wchar_t* WINAPI MlpGetRGBProfileNameW();
	MLPAPI wchar_t* WINAPI MlpGetCMYKProfileNameW();
	MLPAPI wchar_t* WINAPI MlpGetGrayProfileNameW();
	MLPAPI int WINAPI MlpSetColorProfileA(const char* fileName);
	MLPAPI int WINAPI MlpSetRGBProfileA(const char* fileName);
	MLPAPI int WINAPI MlpSetCMYKProfileA(const char* fileName);
	MLPAPI int WINAPI MlpSetGrayProfileA(const char* fileName);
	MLPAPI char* WINAPI MlpGetRGBProfileNameA();
	MLPAPI char* WINAPI MlpGetCMYKProfileNameA();
	MLPAPI char* WINAPI MlpGetGrayProfileNameA();

	/*R[obN*/
	MLPAPI int WINAPI MlpSetCallbackFunc(int mode, int option, void* fnction);

	/*tHg*/
	MLPAPI int WINAPI MlpSetDefaultFontW(const wchar_t* defaultFont);
	MLPAPI int WINAPI MlpSetDefaultFontA(const char* defaultFont);
	MLPAPI int WINAPI MlpSetAlternateFontW(const wchar_t* org, const wchar_t* alt, int always);
	MLPAPI int WINAPI MlpSetAlternateFontA(const char* org, const char* alt, int always);
	MLPAPI int WINAPI MlpSetAlternateFont2W(const wchar_t* org, const wchar_t* alt, const wchar_t* weight, const wchar_t* style, int always, int replace);
	MLPAPI int WINAPI MlpSetAlternateFont2A(const char* org, const char* alt, const char* weight, const char* style, int always, int replace);

	/*EH[^[}[N*/
	MLPAPI int WINAPI MlpSetImageWatermarkW(const wchar_t* fileName, int x_position, int y_position, int z_position, float x_scale, float y_scale, float alpha);
	MLPAPI int WINAPI MlpSetImageWatermarkA(const char* fileName, int x_position, int y_position, int z_position, float x_scale, float y_scale, float alpha);
	MLPAPI int WINAPI MlpSetFillTextWatermarkW(const wchar_t* text, const wchar_t* fontName, int x_position, int y_position, int z_position, float fontSize, const wchar_t* colorName, float alpha);
	MLPAPI int WINAPI MlpSetFillTextWatermarkA(const char* text, const char* fontName, int x_position, int y_position, int z_position, float fontSize, const char* colorName, float alpha);
	MLPAPI int WINAPI MlpSetStrokeTextWatermarkW(const wchar_t* text, const wchar_t* fontName, int x_position, int y_position, int z_position, float fontSize, const wchar_t* colorName, float alpha);
	MLPAPI int WINAPI MlpSetStrokeTextWatermarkA(const char* text, char const* fontName, int x_position, int y_position, int z_position, float fontSize, const char* colorName, float alpha);
	MLPAPI int WINAPI MlpClearWatermarkData();

	/*C[(OCG)*/
	MLPAPI int WINAPI MlpGetOcgCount();
	MLPAPI int WINAPI MlpGetOcgData(MlpOcgData* data[]);
	MLPAPI int WINAPI MlpGetOcgUsage(MlpOcgUsage* data[]);
	MLPAPI int WINAPI MlpSetOcgStateUsage(MlpOcgUsage data[]);

	/*摜*/
	MLPAPI int WINAPI MlpPageToPictW(int pageNumber, int dpi, int quality, const wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpPageToPictA(int pageNumber, int dpi, int quality, const char* outputFilePath);
	MLPAPI int WINAPI MlpPageToPictDataW(int pageNumber, int dpi, int quality, const wchar_t* outputFormat, unsigned long long* length, unsigned char** datap);
	MLPAPI int WINAPI MlpPageToPictDataA(int pageNumber, int dpi, int quality, const char* outputFormat, unsigned long long* length, unsigned char** datap);
	MLPAPI int WINAPI MlpCreatePictW(int pageNumber, const wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpCreatePictA(int pageNumber, const char* outputFilePath);
	MLPAPI int WINAPI MlpCreatePictDataW(int pageNumber, const wchar_t* outputFormat, unsigned long long* len, unsigned char** datap);
	MLPAPI int WINAPI MlpCreatePictDataA(int pageNumber, const char* outputFormat, unsigned long long* len, unsigned char** datap);
	MLPAPI int WINAPI MlpConvertToTiffW(const wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpConvertToTiffA(const char* outputFilePath);
	MLPAPI int WINAPI MlpCreateTiffRangeW(int startPageNumber, int endPageNumber, const wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpCreateTiffRangeA(int startPageNumber, int endPageNumber, const char* outputFilePath);
	MLPAPI int WINAPI MlpCreateTiffMultiW(const wchar_t* pageList, const wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpCreateTiffMultiA(const char* pageList, const char* outputFilePath);
	MLPAPI int WINAPI MlpRangeToTiffW(int startPageNumber, int endPageNumber, int dpi, const wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpRangeToTiffA(int startPageNumber, int endPageNumber, int dpi, const char* outputFilePath);
	MLPAPI int WINAPI MlpPageRangeToTiffW(int startPageNumber, int endPageNumber, int dpi, int quality, const wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpPageRangeToTiffA(int startPageNumber, int endPageNumber, int dpi, int quality, const char* outputFilePath);
	MLPAPI int WINAPI MlpMultiPageToTiffW(const wchar_t* pageList, int dpi, const wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpMultiPageToTiffA(const char* pageList, int dpi, const char* outputFilePath);
	MLPAPI int WINAPI MlpCreateAllToTiffW(const wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpCreateAllToTiffA(const char* outputFilePath);
	MLPAPI int WINAPI MlpCreateAllToPictW(const wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpCreateAllToPictA(const char* outputFilePath);

	/*X^CYhPDF*/
	MLPAPI int WINAPI MlpCreatePDFW(int pageNumber, int img_dpi, int img_quality, wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpCreatePDFA(int pageNumber, int img_dpi, int img_quality, char* outputFilePath);
	MLPAPI int WINAPI MlpCreatePDFFileW(int img_dpi, int img_quality, wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpCreatePDFFileA(int img_dpi, int img_quality, char* outputFilePath);
	MLPAPI int WINAPI MlpCreatePDFArrayW(int* arry_page, int arry_len, int img_dpi, int img_quality, wchar_t* outputFilePpath);
	MLPAPI int WINAPI MlpCreatePDFArrayA(int* arry_page, int arry_len, int img_dpi, int img_quality, char* outputFilePpath);
	MLPAPI int WINAPI MlpAppendToPDFW(int pageNumber, int img_dpi, int img_quality, wchar_t* outputFilePath);
	MLPAPI int WINAPI MlpAppendToPDFA(int pageNumber, int img_dpi, int img_quality, char* outputFilePath);

	/*pl*/
	MLPAPI int WINAPI MlpCreatePanel(int width, int height, int colorspace);
	MLPAPI int WINAPI MlpClearPanel();
	MLPAPI int WINAPI MlpFreePanel();
	MLPAPI int WINAPI MlpPanelToFileW(const wchar_t* filePath);
	MLPAPI int WINAPI MlpPanelToFileA(const char* filePath);
	MLPAPI int WINAPI MlpMemPictToPanel(int x, int y, float alpha);
	MLPAPI int WINAPI MlpMemPictToPanelBBox(int panel_xpos, int panel_ypos, float alpha, int bbox_xpos, int bbox_ypos, int bbox_width, int bbox_height);
	MLPAPI int WINAPI MlpPaintRectToPanel(int xpos, int ypos, int width, int height, int lineWidth, unsigned char* color);
	MLPAPI int WINAPI MlpPaintRectToPanel_2W(int xpos, int ypos, int width, int height, int lineWidth, wchar_t* color);
	MLPAPI int WINAPI MlpPaintRectToPanel_2A(int xpos, int ypos, int width, int height, int lineWidth, char* color);

	/*摜f[^*/
	MLPAPI int WINAPI MlpCreatePictBufPage(int pageNumber, unsigned char** pixels, int* width, int* height, int* nOfColors);
	MLPAPI int WINAPI MlpCreatePictBufPageRange(int firstPageNumber, int lastPageNumber);
	MLPAPI int WINAPI MlpCreatePictBufPageArray(int PageNumberArray[], int length);
	MLPAPI int WINAPI MlpCreatePictMem(int pageNumber);

	/*摜f[^擾ƊJ*/
	MLPAPI int WINAPI MlpGetPictFromMem(unsigned char** pixels, int* width, int* height, int* nOfColors);
	MLPAPI int WINAPI MlpGetPictFromMemIndex(int index, unsigned char** pixels, int* width, int* height, int* nOfColors, int* pageNumber);
	MLPAPI int WINAPI MlpGetPictFromMemPage(int pageNumber, unsigned char** pixels, int* width, int* height, int* nOfColors);
	MLPAPI int WINAPI MlpFreePictMem();

	/*X^v*/
	MLPAPI int WINAPI MlpSetStampFileA(char *filePath);
	MLPAPI int WINAPI MlpSetStampFileW(wchar_t *filePath);
	MLPAPI int WINAPI MlpSetStampDataA(char* data, unsigned int length);
	MLPAPI int WINAPI MlpSetStampDataW(wchar_t* data, unsigned int length);
	MLPAPI int WINAPI MlpPaintStamp();
	MLPAPI int WINAPI MlpPaintStampFileA(char *filePath);
	MLPAPI int WINAPI MlpPaintStampFileW(wchar_t *filePath);
	MLPAPI int WINAPI MlpPaintStampDataA(char* data, unsigned int length);
	MLPAPI int WINAPI MlpPaintStampDataW(wchar_t* data, unsigned int length);
	MLPAPI int WINAPI MlpPaintStampNameA(char *id);
	MLPAPI int WINAPI MlpPaintStampNameW(wchar_t *id);
	MLPAPI int WINAPI MlpPaintStampNamePosA(char *id, float x_pos, float y_pos);
	MLPAPI int WINAPI MlpPaintStampNamePosW(wchar_t *id, float x_pos, float y_pos);
	MLPAPI int WINAPI MlpResetStamp();

	/*X^v C^[tF[X*/
	MLPAPI STAMP_HANDLE WINAPI MlpGetStampInterface();
	MLPAPI void WINAPI StmCloseInterface(STAMP_HANDLE);
	MLPAPI void WINAPI StmFinishInterface(STAMP_HANDLE);

	MLPAPI int WINAPI StmSetStampFileA(STAMP_HANDLE, char* stampFilePath);
	MLPAPI int WINAPI StmSetStampFileW(STAMP_HANDLE, wchar_t* stampFileName);
	MLPAPI int WINAPI StmSetStampDataA(STAMP_HANDLE, char* stampData, unsigned int dataLength);
	MLPAPI int WINAPI StmSetStampDataW(STAMP_HANDLE h, wchar_t* stampData, unsigned int dataLength);
	MLPAPI int WINAPI StmPaintStamp(STAMP_HANDLE);
	MLPAPI int WINAPI StmPaintStampFileA(STAMP_HANDLE, char* stampFileName);
	MLPAPI int WINAPI StmPaintStampFileW(STAMP_HANDLE, wchar_t* stampFileName);
	MLPAPI int WINAPI StmPaintStampDataA(STAMP_HANDLE, char* stampData, unsigned int dataLength);
	MLPAPI int WINAPI StmPaintStampDataW(STAMP_HANDLE, wchar_t* stampData, unsigned int dataLength);
	MLPAPI int WINAPI StmPaintStampNameA(STAMP_HANDLE, char* stampId);
	MLPAPI int WINAPI StmPaintStampNameW(STAMP_HANDLE, wchar_t* stampId);
	MLPAPI int WINAPI StmPaintStampNamePosA(STAMP_HANDLE, char* stampId, float x_pos, float y_pos);
	MLPAPI int WINAPI StmPaintStampNamePosW(STAMP_HANDLE, wchar_t* stampId, float x_pos, float y_pos);
	MLPAPI int WINAPI StmResetStamp(STAMP_HANDLE);
	MLPAPI int WINAPI StmDocumentToFileA(STAMP_HANDLE, char* outputFilePath);
	MLPAPI int WINAPI StmDocumentToFileW(STAMP_HANDLE, wchar_t* outputFilePath);

	/*PDFf[^*/
	MLPAPI int WINAPI MlpRemoveMetadata();
	MLPAPI int WINAPI MlpSavePDFA(char *filePath);
	MLPAPI int WINAPI MlpSavePDFW(wchar_t *filePath);
	MLPAPI int WINAPI MlpInsertPage(int at, float width, float height, int rotate);
	MLPAPI int WINAPI MlpRemovePage(int pageNumber);

	/*T|[g֐*/
	/*摜֘A*/
	MLPAPI int WINAPI MlpCreatePngFromPixels(unsigned char* pixels, int width, int height, int nOfColors, char* outputFilePath);
	MLPAPI int WINAPI MlpCreatePictFromMemPage(int pageNumber, char* outputFilePath);

#endif

#ifdef	__cplusplus
}
#endif

#endif /*STRUCTURE_H*/
